﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            Thread t = new Thread(threadFunc);
            t.IsBackground = true;
            t.Priority = ThreadPriority.BelowNormal;
            t.Start();

            Thread t2 = new Thread(allocThreadFunc);
            t2.IsBackground = true;
            t2.Priority = ThreadPriority.BelowNormal;
            t2.Start();

            {
                Console.ReadLine();
                Console.WriteLine("before: GC.Collect");
                GCCount();
                GC.Collect(2);
                GCCount();
                Console.WriteLine("after: GC.Collect");
                Console.ReadLine();
            }

            {
                Console.WriteLine("before: GC.Collect");
                GCCount();
                GC.Collect(2);
                GCCount();
                Console.WriteLine("after: GC.Collect");
                Console.ReadLine();
            }

            {
                Console.WriteLine("before: GC.Collect");
                GCCount();
                GC.Collect(2);
                GCCount();
                Console.WriteLine("after: GC.Collect");
                Console.ReadLine();
            }
        }

        private static void allocThreadFunc()
        {
            Random rand = new Random(Environment.TickCount);

            while (true)
            {
                int count = rand.Next(500, 1000);
                List<int> list = new List<int>();

                for (int i = 0; i < count; i++)
                {
                    list.Add(i);
                }
            }
        }

        private static void GCCount()
        {
            int cnt = GC.CollectionCount(0) + GC.CollectionCount(1) + GC.CollectionCount(2);
            Console.WriteLine(cnt);
        }

        private static void threadFunc()
        {
            Console.WriteLine("threadFunc TID: " + AppDomain.GetCurrentThreadId());
            long sum = 0;

            for (long i = 0; i < long.MaxValue; i ++)
            {
                sum += i;
            }

            Console.WriteLine("SUM: " + sum);
        }
    }
}
